#include "File.h"

#include <fstream>
#include <iomanip>
#include <cmath>






//!!! Задание на защиту.
//!!! Добавить метод, который заменит запись в бинарном
//!!! файле по месту, без загрузки всего файла в map и без перезаписи.











void File::load_in() {
    accounts_map.clear();
    s = 0;
    std::ifstream in;
    in.open("accounts_data.bin", std::ios::binary);
    if (!in.is_open())
        return;
    Account cur;
    while (in.read(reinterpret_cast<char*>(&cur), sizeof(Account))) {
        s++;
        accounts_map.insert({ s, cur });
    }
    in.close(); //!!! Файл и так закрывается деструктором in
}

void File::load_out() {
    std::ofstream out("accounts_data.bin", std::ios::binary);
    auto iter = accounts_map.begin();
    while (iter != accounts_map.end()) {
        out.write(reinterpret_cast<char*>(&iter->second), sizeof(Account));
        iter++;
    }
    out.close(); //!!! Файл и так закрывается деструктором out
}

File::File() {
    load_in();
}

File::~File() {
    load_out();
    accounts_map.clear();
}

void File::add_account(Account& p) {
    s++;
    std::pair<size_t, Account> c_p(s, p);
    accounts_map.insert(c_p);
    load_out();
}

bool File::search_account_number(const int p) {
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p](const std::pair<size_t, Account>& p2){
                                return p2.second.number == p;
                            });
    if (res == accounts_map.end()) {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end()) {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(Account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, Account>& p2) {
            return p2.second.number == p;
        });
    }
    fout.close();
    return true;
}

bool File::search_account_code(const int p) {
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p](const std::pair<size_t, Account>& p2) {
                                      return p2.second.code == p;
                                  });
    if (res == accounts_map.end()) {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end()) {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(Account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, Account>& p2) {
            return p2.second.code == p;
        });
    }
    fout.close();
    return true;
}
bool File::search_account_surname(const std::string& p) {
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p](const std::pair<size_t, Account>& p2) {
                                      return p2.second.surname == p;
                                  });
    if (res == accounts_map.end()) {
        return false;
    }
    std::ofstream fout("Log.bin", std::ios::binary);
    while (res != accounts_map.end()) {
        fout.write(reinterpret_cast<char*>(&res->second), sizeof(Account));
        std::cout << res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, Account>& p2){
            return p2.second.surname == p;
        });
    }
    fout.close();
    return true;
}

bool File::search_account(const Account& p)
{
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p](const std::pair<size_t, Account>& p2) {
                                      return p2.second == p;
                                  });
    if (res == accounts_map.end()){
        return false;
    }
    std::ofstream out_("Log.bin", std::ios::binary);
    while (res != accounts_map.end()){
        out_.write(reinterpret_cast<char*>(&res->second), sizeof(Account));
        std::cout << std::endl <<  res->second << std::endl << std::endl;
        res++;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, Account>& p2) {
            return p2.second == p;
        });
    }
    out_.close();
    return true;
}

bool File::delete_account(const Account& p) {
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p](const std::pair<size_t, Account>& p2) {
                                      return p2.second == p;
                                  });
    if (res == accounts_map.end()) {
        return false;
    }
    while (res != accounts_map.end()) {
        res = accounts_map.erase(res);
        s--;
        res = std::find_if(res, accounts_map.end(), [&p](const std::pair<size_t, Account>& p2) {
            return p2.second == p;
        });
    }
    load_out();
    return true;
}

bool File::change_account(const Account& p1, const Account& p2) {
    auto res = std::find_if(accounts_map.begin(), accounts_map.end(),
                            [&p1](const std::pair<size_t, Account>& p2) {
                                      return p2.second == p1;
                                  });
    if (res == accounts_map.end()) {
        return false;
    }
    while (res != accounts_map.end()) {
        res->second = p2;
        s--;
        res = std::find_if(res, accounts_map.end(), [&p1](const std::pair<size_t, Account>& p2) {
            return p2.second == p1;
        });
    }
    load_out();
    return true;
}

void File::load_out_txt() {
    auto iter = accounts_map.begin();
    double money_sum = 0;
    double average_percentage = 0;
    std::ofstream txt_out("Out_data.txt");
    txt_out << std::setw(15) <<
            "Account number" << "|" << std::setw(15) <<
            "Account code" << "|" << std::setw(15) <<
            "Surname" << "|" << std::setw(15) <<
            "Money balance" << "|" << std::setw(25) <<
            "Account creation date" << "|" << std::setw(15) <<
            "Annual percentage" << std::endl << std::string(107, '-') << std::endl;
    while (iter != accounts_map.end()) {
        money_sum += iter->second.money;
        average_percentage += iter->second.annual_percentage;
        txt_out << std::setw(15) <<
                iter->second.number << "|" << std::setw(15) <<
                iter->second.code << "|" << std::setw(15) <<
                iter->second.surname << "|" << std::setw(15) <<
                iter->second.money << "|" << std::setw(25) <<
                iter->second.creation_date << "|" << std::setw(15) <<
                iter->second.annual_percentage << "%" << std::endl;
        iter++;
    }
    txt_out << std::endl << std::endl <<  "Total amount of accounts: " << accounts_map.size() << std::endl <<
            "Money sum on all accounts: " << money_sum << std::endl <<
            "Average annual percentage: " << round(average_percentage / accounts_map.size() * 100) / 100 << "%" << std::endl;
    txt_out.close();
}
